Package com.collabnet.ce.soap60.webservices.pluggable

# Interface IPluggableAppSoap

All Known Implementing Classes:
  `PluggableAppSoap`, `PluggableAppSoapMockStub`, `PluggableAppSoapStub`

public interface IPluggableAppSoap

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PluggableComponentSoapDO`
  `createIntegratedApplication(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplication2(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplication3(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileKey, String iconFileName, String iconMimeType, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `createIntegratedApplication4(String sessionId, PluggableComponent3SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `createIntegratedApplication5(String sessionId, PluggableComponent4SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `createIntegratedApplication6(String sessionId, PluggableComponent5SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType)`
  Creates a Integrated Application Note that the icon file has to be uploaded seperately
  `PluggableComponentSoapDO`
  `createIntegratedApplicationFromXMLFiles(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplicationFromXMLFiles2(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `createIntegratedApplicationFromXMLFiles3(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `createIntegratedApplicationFromXMLFiles4(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `createIntegratedApplicationFromXMLFiles5(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `createIntegratedApplicationFromXMLFiles6(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType)`
  Create/import an integrated application from XML files.
  `void`
  `deleteIntegratedApplication(String sessionId, String plugName)`
  Delete an integrated application at the site level
  `void`
  `editIntegratedApplication(String sessionId, PluggableComponentSoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication2(String sessionId, PluggableComponent2SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication3(String sessionId, PluggableComponent3SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication4(String sessionId, PluggableComponent4SoapDO soapDO)`
  Deprecated.
  `void`
  `editIntegratedApplication5(String sessionId, PluggableComponent5SoapDO soapDO)`
  Edit the integrated application properties.
  `void`
  `editIntegratedApplicationFromXMLFiles(String sessionId, String integratedAppId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId)`
  Edit integrated application from xml files.
  `SoapNamedValues`
  `editProjectConfigurationParameters(String sessionId, String projectId, PluggableComponentParameterSoapDO[] paramDO)`
  Deprecated.
  `SoapNamedValues`
  `editProjectConfigurationParameters2(String sessionId, String integratedAppId, String projectId, PluggableComponentParameterSoapDO[] paramDO)`
  Edit the project specific configuration parameters of an integrated application.
  `SoapNamedValues`
  `enablePluggableComponent(String sessionId, String projectID, String pluggableId, PluggableComponentParameterSoapDO[] params, String prefix)`
  Adds a pluggable application to a project
  `String`
  `getBaseUrlByLinkId(String sessionId, String linkId)`
  Get the project integrated application's base URL.
  `String`
  `getBaseUrlByName(String sessionId, String iaName)`
  Gets integrated application base url for the given IA Name
  `PluggableComponentSoapDO`
  `getIntegratedApplicationByName(String sessionId, String plugName)`
  Deprecated.
  `PluggableComponent2SoapDO`
  `getIntegratedApplicationByName2(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent3SoapDO`
  `getIntegratedApplicationByName3(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent4SoapDO`
  `getIntegratedApplicationByName4(String sessionId, String integratedAppName)`
  Deprecated.
  `PluggableComponent5SoapDO`
  `getIntegratedApplicationByName5(String sessionId, String integratedAppName)`
  Get the integrated application for a given name.
  `String[]`
  `getIntegratedAppPrefixes(String sessionId)`
  Gets the list of Integrated App Prefixes.
  `String`
  `getLinkPlugId(String sessionId, String projectPath, String baseUrl)`
  Gets the link id for the specified project and base URL.
  `String`
  `getLinkPlugIdByPlugId(String sessionId, String projectId, String pluggableId)`
  Get the integrated application id for the specified project and base URL.
  `String`
  `getPlugIdByBaseUrl(String sessionId, String baseUrl)`
  Gets integrated application id for the given base URL
  `PluggableComponentParameterSoapDO[]`
  `getProjectConfigParameterData(String sessionId, String linkId)`
  Gets project specific configuration parameters for a pluggable application.
  `String`
  `getProjectPathByIntegratedAppId(String sessionId, String linkId)`
  Get the project path for the given integrated application id.
  `String`
  `getProjectPrefix(String sessionId, String linkId)`
  Get the project prefix for an integrated application.
  `PluggableComponentSoapList`
  `listPluggableComponents(String sessionId)`
  Deprecated.
  `PluggableComponent2SoapList`
  `listPluggableComponents2(String sessionId)`
  Gets the list of integrated applications in the site.
  `PluggableComponent2SoapList`
  `listPluggableComponentsByCategory(String sessionId, String category)`
  Gets the list of integrated applications in the site based on the category.
  `LinkPluggableComponentSoapList`
  `listPluggableComponentsForProject(String sessionId, String projectId)`
  Lists Pluggable Components.
  `void`
  `removeProjectIntegratedApplication(String sessionId, String linkId)`
  Removes integrated application from a project.
  `void`
  `setIntegratedApplicationIcon(String sessionId, String integratedAppId, String iconFileKey, String iconFileName, String iconMimeType)`
  Sets new icon for specified integrated application
  `void`
  `setPluggableAppMessageResource(String sessionId, String pluggableId, String locale, String key, String value)`
  Creates / Updates the Pluggable App Message resource
  `void`
  `updateRecentAccess(String userId, String objectId)`
  Updates the recent access entries for the user.

- ## Method Details

  - ### listPluggableComponents

    @Deprecated PluggableComponentSoapList listPluggableComponents(String sessionId) throws RemoteException
    Deprecated.
    Gets the list of integrated applications in the site.
    Parameters:
      `sessionId` - UserSession ID.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### listPluggableComponents2

    PluggableComponent2SoapList listPluggableComponents2(String sessionId) throws RemoteException
    Gets the list of integrated applications in the site.
    Parameters:
      `sessionId` - UserSession ID.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      8.0

  - ### listPluggableComponentsByCategory

    PluggableComponent2SoapList listPluggableComponentsByCategory(String sessionId, String category) throws RemoteException
    Gets the list of integrated applications in the site based on the category.
    Parameters:
      `sessionId` - UserSession ID.
      `category` - category of the integrated application.
    Returns:
      list of integrated applications in the site.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      8.0

  - ### enablePluggableComponent

    SoapNamedValues enablePluggableComponent(String sessionId, String projectID, String pluggableId, PluggableComponentParameterSoapDO[] params, String prefix) throws RemoteException
    Adds a pluggable application to a project
    Parameters:
      `sessionId` - UserSession ID.
      `projectID` - Project ID project to which the pluggable app should be added.
      `pluggableId` - pluggable application that should be added to a project
      `params` - Param Array of PluggableComponentParameter Values
      `prefix` - the pluggablecomponent prefix
    Returns:
      name/value pair of validation errors if any
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project/integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `IntegratedAppDisabledFault` - thrown when the integrated application is disabled from addition to projects
      `RemoteException`
    Since:
      5.0

  - ### getProjectConfigParameterData

    PluggableComponentParameterSoapDO[] getProjectConfigParameterData(String sessionId, String linkId) throws RemoteException
    Gets project specific configuration parameters for a pluggable application.
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - the link id between a pluggable application and a project
    Returns:
      array of project specific configuration parameters
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### editProjectConfigurationParameters

    @Deprecated SoapNamedValues editProjectConfigurationParameters(String sessionId, String projectId, PluggableComponentParameterSoapDO[] paramDO) throws RemoteException
    Deprecated.
    Edits project specific configuration parameters of a pluggable application.
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - project in which the pluggable application resides.
      `paramDO` - project specific configuration parameters for a pluggable application
    Returns:
      name/value pair of validation errors if any, where name is the parameter name and value is the error string.
    Throws:
      `NoSuchObjectFault` - when the specified project id or the configuration params is invalid.
      `InvalidSessionFault` - when the specified session id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      5.0

  - ### editProjectConfigurationParameters2

    SoapNamedValues editProjectConfigurationParameters2(String sessionId, String integratedAppId, String projectId, PluggableComponentParameterSoapDO[] paramDO) throws RemoteException
    Edit the project specific configuration parameters of an integrated application.
    Parameters:
      `sessionId` - Soap session ID
      `integratedAppId` - integrated application ID
      `projectId` - project in which the integrated application resides
      `paramDO` - project specific configuration parameters of an integrated application
    Returns:
      name/value pair of validation errors if any, where name is the parameter name and value is the error string.
    Throws:
      `NoSuchObjectFault` - thrown if given project id or the configuration parameter is invalid.
      `InvalidSessionFault` - thrown if the soap session is invalid.
      `SystemFault` - thrown on the occurrence of an unexpected system level error.
      `PermissionDeniedFault` - thrown if the user has insufficient privileges.
      `RemoteException`
    Since:
      6.1.1

  - ### deleteIntegratedApplication

    void deleteIntegratedApplication(String sessionId, String plugName) throws RemoteException
    Delete an integrated application at the site level
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
    Since:
      17.11

  - ### removeProjectIntegratedApplication

    void removeProjectIntegratedApplication(String sessionId, String linkId) throws RemoteException
    Removes integrated application from a project.
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - project pluggable application id
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project integrated appln. id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### listPluggableComponentsForProject

    LinkPluggableComponentSoapList listPluggableComponentsForProject(String sessionId, String projectId) throws RemoteException
    Lists Pluggable Components. Gives the list of pluggable components available for a project
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - Project ID.
    Returns:
      pcList PluggableComponentList.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified project id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### getLinkPlugId

    String getLinkPlugId(String sessionId, String projectPath, String baseUrl) throws RemoteException
    Gets the link id for the specified project and base URL.
    Parameters:
      `sessionId` - UserSession ID.
      `projectPath` - the project path
      `baseUrl` - integrated application base URL
    Returns:
      integrated application id for the specified project and base URL
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - thrown when an association between the iaf and the project does not exist
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      5.0

  - ### getProjectPathByIntegratedAppId

    String getProjectPathByIntegratedAppId(String sessionId, String linkId) throws RemoteException
    Get the project path for the given integrated application id.
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - linkId id of integrated application id/prpl id
    Returns:
      project path for the given integrated application.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application id is invalid
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      5.0

  - ### getBaseUrlByLinkId

    String getBaseUrlByLinkId(String sessionId, String linkId) throws RemoteException
    Get the project integrated application's base URL.
    Parameters:
      `sessionId` - UserSession ID.
      `linkId` - project integrated application id.
    Returns:
      the project integrated application's base URL
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application id is invalid
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      5.0

  - ### getPlugIdByBaseUrl

    String getPlugIdByBaseUrl(String sessionId, String baseUrl) throws RemoteException
    Gets integrated application id for the given base URL
    Parameters:
      `sessionId` - UserSession ID.
      `baseUrl` - integrated application base URL
    Returns:
      integrated application id
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `RemoteException`
    Since:
      5.0

  - ### getBaseUrlByName

    String getBaseUrlByName(String sessionId, String iaName) throws RemoteException
    Gets integrated application base url for the given IA Name
    Parameters:
      `sessionId` - UserSession ID.
      `iaName` - integrated application name
    Returns:
      baseUrl
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `RemoteException`
    Since:
      20.3

  - ### createIntegratedApplication

    @Deprecated PluggableComponentSoapDO createIntegratedApplication(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle) throws RemoteException
    Deprecated.
    Creates a Integrated Application
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileId` - the iconfileId
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration. the PluggableComponentParameterSoapDO
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
    Returns:
      a `PluggableComponentSoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `RemoteException`
    Since:
      6.0

  - ### createIntegratedApplication2

    @Deprecated PluggableComponent2SoapDO createIntegratedApplication2(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileId, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType) throws RemoteException
    Deprecated.
    Creates a Integrated Application
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileId` - the iconfileId
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration.
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
      `idPattern` - Regular expression for the object id which used for creating association links.
      `serviceType` - The service type REST / SOAP
    Returns:
      a `PluggableComponent2SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `RemoteException`
    Since:
      6.1.1

  - ### createIntegratedApplication3

    @Deprecated PluggableComponent2SoapDO createIntegratedApplication3(String sessionId, String plugName, String description, String baseUrl, String goUrl, String prefix, String isScmRequired, String requireProjPrefix, String iconFileKey, String iconFileName, String iconMimeType, String endPoint, PluggableComponentParameterSoapDO[] paramDO, String adminUrl, PluggablePermissionSoapDO[] permSoapDO, String isPageComponentRequired, String pceInputType, String pceResultFormat, String pceDescription, String pceTitle, String idPattern, String serviceType) throws RemoteException
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately
    Parameters:
      `sessionId` - the soap session ID
      `plugName` - the integratedApp Name
      `description` - the integratedApp description
      `baseUrl` - the app's baseUrl
      `goUrl` - the goUrl
      `prefix` - the app's prefix
      `isScmRequired` - the isScmRequired
      `requireProjPrefix` - the project prefix
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
      `endPoint` - the endPoint
      `paramDO` - the PluggableComponentParameterSoapDO
      `adminUrl` - url for integrated app. site administration.
      `permSoapDO` - the PluggablePermissionSoapDO
      `pceInputType` - pceInputType of integrated app
      `pceResultFormat` - pceResultFormat of integrated app
      `pceDescription` - pceDescription of integrated app
      `pceTitle` - pceTitle of integrated app
      `idPattern` - Regular expression for the object id which used for creating association links.
      `serviceType` - The service type REST / SOAP
    Returns:
      a `PluggableComponent2SoapDO` of the created application
    Since:
      7.0

  - ### createIntegratedApplication4

    @Deprecated PluggableComponent3SoapDO createIntegratedApplication4(String sessionId, PluggableComponent3SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent3SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent3SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      7.2

  - ### createIntegratedApplication5

    @Deprecated PluggableComponent4SoapDO createIntegratedApplication5(String sessionId, PluggableComponent4SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Deprecated.
    Creates a Integrated Application Note that the icon file has to be uploaded seperately
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent4SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent4SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      8.0

  - ### createIntegratedApplication6

    PluggableComponent5SoapDO createIntegratedApplication6(String sessionId, PluggableComponent5SoapDO soapDO, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Creates a Integrated Application Note that the icon file has to be uploaded seperately
    Parameters:
      `sessionId` - the soap session ID
      `soapDO` - a `PluggableComponent5SoapDO` with integrated application properties
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent5SoapDO` of the created application
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault`
      `IllegalArgumentFault`
      `ObjectAlreadyExistsFault`
      `SystemFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      16.7

  - ### createIntegratedApplicationFromXMLFiles

    @Deprecated PluggableComponentSoapDO createIntegratedApplicationFromXMLFiles(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws RemoteException
    Deprecated.
    Creates/Imports an integrated application from xml files.
    Parameters:
      `sessionId` - user session id
      `depXmlByteArray` - integrated app deployment xml byte array
      `appXmlByteArray` - integrated app application xml byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Returns:
      PluggableComponentSoapDO with the details of the integrated application that was created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `RemoteException`
    Since:
      6.1

  - ### createIntegratedApplicationFromXMLFiles2

    @Deprecated PluggableComponent2SoapDO createIntegratedApplicationFromXMLFiles2(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws RemoteException
    Deprecated.
    Create/import an integrated application from XML files.
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Returns:
      a `PluggableComponent2SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `RemoteException`
    Since:
      6.1.1

  - ### createIntegratedApplicationFromXMLFiles3

    @Deprecated PluggableComponent2SoapDO createIntegratedApplicationFromXMLFiles3(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Deprecated.
    Create/import an integrated application from XML files.
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent2SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      7.0

  - ### createIntegratedApplicationFromXMLFiles4

    @Deprecated PluggableComponent3SoapDO createIntegratedApplicationFromXMLFiles4(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Deprecated.
    Create/import an integrated application from XML files.
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent3SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      7.2

  - ### createIntegratedApplicationFromXMLFiles5

    @Deprecated PluggableComponent4SoapDO createIntegratedApplicationFromXMLFiles5(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Deprecated.
    Create/import an integrated application from XML files.
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent4SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      8.0

  - ### createIntegratedApplicationFromXMLFiles6

    PluggableComponent5SoapDO createIntegratedApplicationFromXMLFiles6(String sessionId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Create/import an integrated application from XML files.
    Parameters:
      `sessionId` - soap session ID
      `depXmlByteArray` - integrated application deployment XML byte array
      `appXmlByteArray` - integrated application application XML byte array
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service)
      `iconFileName` - the name of the icon file
      `iconMimeType` - the mime-type of the icon file (supported icon file formats are GIF/JPEG/PNG)
    Returns:
      a `PluggableComponent5SoapDO` for the integrated application that was just created.
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `ObjectAlreadyExistsFault` - thrown when an application by the same name/prefix/baseurl exist
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault`
      `NoSuchObjectFault`
      `RemoteException`
    Since:
      16.7

  - ### getIntegratedApplicationByName

    @Deprecated PluggableComponentSoapDO getIntegratedApplicationByName(String sessionId, String plugName) throws RemoteException
    Deprecated.
    Returns the PluggableComponentSoapDO object for the given Integrated Application Name
    Parameters:
      `sessionId` - the soap sessionid
      `plugName` - the Integrated App Name
    Returns:
      PluggableComponentSoapDO object
    Throws:
      `InvalidSessionFault` - when the session is invalid.
      `NoSuchObjectFault`
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      6.0

  - ### getIntegratedApplicationByName2

    @Deprecated PluggableComponent2SoapDO getIntegratedApplicationByName2(String sessionId, String integratedAppName) throws RemoteException
    Deprecated.
    Get the integrated application for a given name.
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent2SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
      `RemoteException`
    Since:
      6.1.1

  - ### getIntegratedApplicationByName3

    @Deprecated PluggableComponent3SoapDO getIntegratedApplicationByName3(String sessionId, String integratedAppName) throws RemoteException
    Deprecated.
    Get the integrated application for a given name.
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent3SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
      `RemoteException`
    Since:
      7.2

  - ### getIntegratedApplicationByName4

    @Deprecated PluggableComponent4SoapDO getIntegratedApplicationByName4(String sessionId, String integratedAppName) throws RemoteException
    Deprecated.
    Get the integrated application for a given name.
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent4SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
      `RemoteException`
    Since:
      8.0

  - ### getIntegratedApplicationByName5

    PluggableComponent5SoapDO getIntegratedApplicationByName5(String sessionId, String integratedAppName) throws RemoteException
    Get the integrated application for a given name.
    Parameters:
      `sessionId` - soap session ID
      `integratedAppName` - integrated application name
    Returns:
      `PluggableComponent5SoapDO` for a given integrated application name
    Throws:
      `InvalidSessionFault` - thrown when the soap session is invalid
      `NoSuchObjectFault` - thrown if the given integrated application name does not exist
      `RemoteException`
    Since:
      16.7

  - ### editIntegratedApplication

    @Deprecated void editIntegratedApplication(String sessionId, PluggableComponentSoapDO soapDO) throws RemoteException
    Deprecated.
    Edits the Integrated Application for the giving PluggableComponentSoapDO
    Parameters:
      `sessionId` - the soap sessionId
      `soapDO` - the PluggableComponentSoapDO
    Throws:
      `InvalidSessionFault` - when session is invalid
      `PermissionDeniedFault` - when current user doesn't have enough permission
      `IllegalArgumentFault` - when given PluggableComponetSoapDO has invalid value
      `SystemFault` - when an unexpected system level error occurs.
      `NoSuchObjectFault` - when the integrated app with the given details does not exists.
      `RemoteException`
    Since:
      6.0

  - ### editIntegratedApplication2

    @Deprecated void editIntegratedApplication2(String sessionId, PluggableComponent2SoapDO soapDO) throws RemoteException
    Deprecated.
    Edit the integrated application properties.
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent2SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
      `RemoteException`
    Since:
      6.1.1

  - ### editIntegratedApplication3

    @Deprecated void editIntegratedApplication3(String sessionId, PluggableComponent3SoapDO soapDO) throws RemoteException
    Deprecated.
    Edit the integrated application properties.
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent3SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
      `RemoteException`
    Since:
      7.2

  - ### editIntegratedApplication4

    @Deprecated void editIntegratedApplication4(String sessionId, PluggableComponent4SoapDO soapDO) throws RemoteException
    Deprecated.
    Edit the integrated application properties.
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent4SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
      `RemoteException`
    Since:
      8.0

  - ### editIntegratedApplication5

    void editIntegratedApplication5(String sessionId, PluggableComponent5SoapDO soapDO) throws RemoteException
    Edit the integrated application properties.
    Parameters:
      `sessionId` - soap session ID
      `soapDO` - a `PluggableComponent5SoapDO` with the properties to be edited.
    Throws:
      `InvalidSessionFault` - thrown if the session is invalid
      `PermissionDeniedFault` - thrown if the user has insufficient privileges
      `IllegalArgumentFault` - thrown if application properties are invalid
      `SystemFault` - thrown if there is an error when marshaling the SOAP object
      `NoSuchObjectFault` - thrown if an integrated application with the given details does not exists
      `RemoteException`
    Since:
      16.7

  - ### editIntegratedApplicationFromXMLFiles

    void editIntegratedApplicationFromXMLFiles(String sessionId, String integratedAppId, byte[] depXmlByteArray, byte[] appXmlByteArray, String iconFileId) throws RemoteException
    Edit integrated application from xml files. Note that input xml files have to be uploaded as byte arrays
    Parameters:
      `sessionId` - user session id
      `depXmlByteArray` - integrated app deployment xml byte array
      `appXmlByteArray` - integrated app application xml byte array
      `iconFileId` - icon file id, should be a StoredFileKey id
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `NoSuchObjectFault` - thrown when an application doesn not exists with the given id
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `RemoteException`
    Since:
      6.1.1

  - ### setIntegratedApplicationIcon

    void setIntegratedApplicationIcon(String sessionId, String integratedAppId, String iconFileKey, String iconFileName, String iconMimeType) throws RemoteException
    Sets new icon for specified integrated application
    Parameters:
      `sessionId` - soap session ID
      `integratedAppId` - integrated application for which the icon to be set
      `iconFileKey` - the uploaded icon file key (through FileStorageApp or SimpleFileStorageApp service).
      `iconFileName` - the icon file name
      `iconMimeType` - the mime-type of the icon
    Throws:
      `InvalidSessionFault` - thrown when the session is invalid
      `PermissionDeniedFault` - thrown when the user does not have the permission to perform this operation
      `SystemFault` - thrown when the content/syntax of the XML is invalid or any other system error
      `IllegalArgumentFault` - thrown if any of the parameters is not set
      `NoSuchObjectFault` - thrown when the specified integrated application does not exist.
      `RemoteException`
    Since:
      8.0

  - ### getLinkPlugIdByPlugId

    String getLinkPlugIdByPlugId(String sessionId, String projectId, String pluggableId) throws RemoteException
    Get the integrated application id for the specified project and base URL.
    Parameters:
      `sessionId` - UserSession ID.
      `projectId` - the project ID
      `pluggableId` - integrated application ID.
    Returns:
      integrated application link id for the specified project and pluggableId
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      6.0

  - ### getProjectPrefix

    String getProjectPrefix(String sessionId, String linkId) throws RemoteException
    Get the project prefix for an integrated application.
    Parameters:
      `sessionId` - UserSession Id.
      `linkId` - , integrated application link id
    Returns:
      project prefix for an integrated application.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified integrated application does not exist.
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      6.0.1

  - ### updateRecentAccess

    void updateRecentAccess(String userId, String objectId) throws RemoteException
    Updates the recent access entries for the user.
    Parameters:
      `userId` - user who recently accessed this object
      `objectId` - recently accessed object id of the form glpl_prplXXXX_prefix_objectId_objectTitle
    Throws:
      `IllegalArgumentFault` - thrown when the objectId is invalid
      `RemoteException`
    Since:
      6.0.1

  - ### getIntegratedAppPrefixes

    String[] getIntegratedAppPrefixes(String sessionId) throws RemoteException
    Gets the list of Integrated App Prefixes.
    Parameters:
      `sessionId` - the Session id of the user
    Returns:
      Array List of Integrated App Prefixes.
    Throws:
      `InvalidSessionFault` - when session is invalid
      `RemoteException`
    Since:
      6.0.1

  - ### setPluggableAppMessageResource

    void setPluggableAppMessageResource(String sessionId, String pluggableId, String locale, String key, String value) throws RemoteException
    Creates / Updates the Pluggable App Message resource
    Parameters:
      `pluggableId` - The Pluggable Id for which this message resource to be created
      `locale` - The Locale
      `key` - The Resource Key
      `value` - The Resource Value
    Throws:
      `SystemFault` - when an unexpected system level error occurs.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `RemoteException`
    Since:
      6.0.1